Bug 1272668 - Review Request: nodejs-arrify - Convert a value to an array
Review Request: nodejs-arrify - Convert a value to an array
Status: CLOSED ERRATA
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Jared Smith
Fedora Extras Quality Assurance
:
Depends On:
Blocks: 1194923
  Show dependency treegraph
 
Reported: 2015-10-17 09:22 EDT by Piotr Popieluch
Modified: 2015-11-23 15:05 EST (History)
3 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2015-11-17 10:51:19 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
jsmith.fedora: fedora‑review+


Attachments (Terms of Use)

  None (edit)
Description Piotr Popieluch 2015-10-17 09:22:42 EDT
Spec URL: https://piotrp.fedorapeople.org/nodejs-arrify.spec
SRPM URL: https://piotrp.fedorapeople.org/nodejs-arrify-1.0.0-1.fc22.src.rpm
Description: Convert a value to an array
Fedora Account System Username: piotrp
Comment 1 Jared Smith 2015-10-22 13:15:26 EDT
A few comments (that also apply to some of your other outstanding package requests for nodejs-packages):

1.  Use tarballs from the NPM registry.  See https://fedoraproject.org/wiki/Packaging:Node.js?rd=Node.js/Packagers#Using_tarballs_from_the_npm_registry

Please note that the RPM registry tarballs don't contain the tests, so you'll need to pull them separately.  Since the test is a single file, you can simply grab it like this:

%{?nodejs_find_provides_and_requires}

%global packagename arrify
%global github_tag_hash 4576e944677c722c356480b17a6d709d34d0733c
%global enable_tests 0
# Tests are disabled until 'ava' is packaged in Fedora
# See https://bugzilla.redhat.com/show_bug.cgi?id=1194923

Name:           nodejs-arrify
Version:        1.0.0
Release:        1%{?dist}
Summary:        Convert a value to an array

License:        MIT
URL:            https://github.com/sindresorhus/arrify
Source0:        https://registry.npmjs.org/%{packagename}/-/%{packagename}-%{version}.tgz
# npm registry doesn't contain tests, so get the test file from the github repo
Source1:        https://raw.githubusercontent.com/sindresorhus/arrify/%{github_tag_hash}/test.js

2. Your %check section should use the testing method specified in the package.json file.  In this case, you wouldn't run mocha, but instead run /usr/bin/node test.js

3. In your %files section, you can add the following line (directly below the %files line) so that the same spec file can be used in EPEL6, where there is no %license macro:

%{!?_licensedir:%global license %doc}


Please fix those three items, and I'll do the formal package review on this and the other dependencies for 'ava'.
Comment 2 Piotr Popieluch 2015-10-22 15:54:03 EDT
Thanks for checking. 

Many modules in NPM have no tests or license included. If that is the case I prefer to use github sources instead of downloading and attaching all files manually.

I will fix the tests. 

I don't plan to push any new node modules to EPEL6.
Comment 3 Jared Smith 2015-10-22 17:03:32 EDT
(In reply to Piotr Popieluch from comment #2)
> Many modules in NPM have no tests or license included. If that is the case I
> prefer to use github sources instead of downloading and attaching all files
> manually.

Yes, I know it's more work -- but it's specifically what has been decided in to the NodeJS packaging guidelines.  

For packages that have a "test" subdirectory instead of just a single file, I took a script that Jamie had created and amplified it, and it's working pretty well.  See https://jsmith.fedorapeople.org/Packaging/nodejs-testit/ as an example of how I handle it now.

Also, I know that you're not planning to push any new modules to EPEL6, but others might want them, and it's not hard to add one line to make their lives easier.
Comment 4 Piotr Popieluch 2015-10-23 03:06:51 EDT
I could change to NPM for this module. I'm a bit more worried about modules which don't ship the license in NPM (not ship license separate from source) or are generated and don't ship the sources (build from source).

I'll send a mail to nodejs mailinglist next week to discuss this, maybe we should update the guidelines a bit.

Unfortunately the license macro is not the only extra line needed for EPEL6, also needed:
- nodejs_find_provides macro
- conditionalized ExclusiveArch
- conditionalize test section as many test libraries will not be in EPEL6
- conditionalize fixdeps, EPEL6 will have older versions. (If you actually can push the most recent version.)
- dozens of missing dependencies..
Comment 5 Piotr Popieluch 2015-10-23 15:29:44 EDT
I've started the Source0 discussion on the mailinglist:

https://lists.fedoraproject.org/pipermail/nodejs/2015-October/thread.html
Comment 6 Jared Smith 2015-10-28 12:16:47 EDT
In the meantime, please submit an updated spec and SRPM with the fixed tests, and I'll approve the package.
Comment 7 Piotr Popieluch 2015-10-28 13:41:08 EDT
Excuse me for delay. I've updated test section, see the same url's.
Comment 8 Jared Smith 2015-11-05 15:58:08 EST
Package is approved.  Thanks for packaging this for Fedora.

Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed



===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "MIT/X11 (BSD like)", "Unknown or generated". 8 files have
     unknown license.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[-]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 10240 bytes in 1 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any
     that are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[x]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[-]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Sources can be downloaded from URI in Source: tag
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: SourceX is a working URL.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: nodejs-arrify-1.0.0-1.fc24.noarch.rpm
          nodejs-arrify-1.0.0-1.fc24.src.rpm
nodejs-arrify.noarch: W: only-non-binary-in-usr-lib
2 packages and 0 specfiles checked; 0 errors, 1 warnings.




Rpmlint (installed packages)
----------------------------
sh: /usr/bin/python: No such file or directory
nodejs-arrify.noarch: W: only-non-binary-in-usr-lib
1 packages and 0 specfiles checked; 0 errors, 1 warnings.



Requires
--------
nodejs-arrify (rpmlib, GLIBC filtered):
    nodejs(engine)



Provides
--------
nodejs-arrify:
    nodejs-arrify
    npm(arrify)



Source checksums
----------------
https://github.com/sindresorhus/arrify/archive/4576e944677c722c356480b17a6d709d34d0733c.tar.gz#/arrify-4576e94.tar.gz :
  CHECKSUM(SHA256) this package     : 462fc351720336a3dbb74f043a2a6c948f6aaba560504dc465e7747485f0cd45
  CHECKSUM(SHA256) upstream package : 462fc351720336a3dbb74f043a2a6c948f6aaba560504dc465e7747485f0cd45


Generated by fedora-review 0.6.0 (3c5c9d7) last change: 2015-05-20
Command line :/usr/bin/fedora-review -b 1272668
Buildroot used: fedora-rawhide-x86_64
Active plugins: Generic, Shell-api
Disabled plugins: Java, C/C++, Python, fonts, SugarActivity, Ocaml, Perl, Haskell, R, PHP, Ruby
Disabled flags: EXARCH, DISTTAG, EPEL5, BATCH, EPEL6
Comment 9 Piotr Popieluch 2015-11-06 03:48:48 EST
Thank you for review
Comment 10 Gwyn Ciesla 2015-11-06 07:49:11 EST
Package request has been approved: https://admin.fedoraproject.org/pkgdb/package/nodejs-arrify
Comment 11 Fedora Update System 2015-11-06 08:53:10 EST
nodejs-arrify-1.0.0-1.fc23 has been submitted as an update to Fedora 23. https://bodhi.fedoraproject.org/updates/FEDORA-2015-619c7100b9
Comment 12 Fedora Update System 2015-11-06 08:53:36 EST
nodejs-arrify-1.0.0-1.fc22 has been submitted as an update to Fedora 22. https://bodhi.fedoraproject.org/updates/FEDORA-2015-8a50091e30
Comment 13 Fedora Update System 2015-11-06 08:53:57 EST
nodejs-arrify-1.0.0-1.el7 has been submitted as an update to Fedora EPEL 7. https://bodhi.fedoraproject.org/updates/FEDORA-EPEL-2015-f7dd91fd67
Comment 14 Fedora Update System 2015-11-06 08:54:27 EST
nodejs-std-mocks-1.0.0-1.fc23 has been submitted as an update to Fedora 23. https://bodhi.fedoraproject.org/updates/FEDORA-2015-75225b3fa6
Comment 15 Fedora Update System 2015-11-06 08:54:45 EST
nodejs-std-mocks-1.0.0-1.fc22 has been submitted as an update to Fedora 22. https://bodhi.fedoraproject.org/updates/FEDORA-2015-49ed56059b
Comment 16 Fedora Update System 2015-11-06 08:55:05 EST
nodejs-std-mocks-1.0.0-1.el7 has been submitted as an update to Fedora EPEL 7. https://bodhi.fedoraproject.org/updates/FEDORA-EPEL-2015-659a964be0
Comment 17 Fedora Update System 2015-11-08 07:26:55 EST
nodejs-arrify-1.0.0-1.fc22 has been pushed to the Fedora 22 testing repository. If problems still persist, please make note of it in this bug report.
If you want to test the update, you can install it with
$ su -c 'dnf --enablerepo=updates-testing update nodejs-arrify'
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2015-8a50091e30
Comment 18 Fedora Update System 2015-11-08 08:24:35 EST
nodejs-arrify-1.0.0-1.fc23 has been pushed to the Fedora 23 testing repository. If problems still persist, please make note of it in this bug report.
If you want to test the update, you can install it with
$ su -c 'dnf --enablerepo=updates-testing update nodejs-arrify'
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2015-619c7100b9
Comment 19 Fedora Update System 2015-11-08 13:49:58 EST
nodejs-arrify-1.0.0-1.el7 has been pushed to the Fedora EPEL 7 testing repository. If problems still persist, please make note of it in this bug report.
If you want to test the update, you can install it with
$ su -c 'yum --enablerepo=epel-testing update nodejs-arrify'
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-EPEL-2015-f7dd91fd67
Comment 20 Fedora Update System 2015-11-17 10:51:17 EST
nodejs-arrify-1.0.0-1.fc23 has been pushed to the Fedora 23 stable repository. If problems still persist, please make note of it in this bug report.
Comment 21 Fedora Update System 2015-11-17 13:22:41 EST
nodejs-arrify-1.0.0-1.fc22 has been pushed to the Fedora 22 stable repository. If problems still persist, please make note of it in this bug report.
Comment 22 Fedora Update System 2015-11-23 15:05:46 EST
nodejs-arrify-1.0.0-1.el7 has been pushed to the Fedora EPEL 7 stable repository. If problems still persist, please make note of it in this bug report.

Note You need to log in before you can comment on or make changes to this bug.